diff --git a/fs/lustre/ptlrpc/pack_generic.c b/fs/lustre/ptlrpc/pack_generic.c
index 16058b9cd9be..61fd122e8e3f 100644
--- a/fs/lustre/ptlrpc/pack_generic.c
+++ b/fs/lustre/ptlrpc/pack_generic.c
@@ -2299,7 +2299,6 @@ void lustre_swab_lov_comp_md_v1(struct lov_comp_md_v1 *lum)
 		__swab32s(&ent->lcme_layout_gen);
 		/* no need to swab lcme_dstripe_count */
 		/* no need to swab lcme_cstripe_count */
-		BUILD_BUG_ON(offsetof(typeof(*ent), lcme_padding_1) == 0);
 
 		v1 = (struct lov_user_md_v1 *)((char *)lum + off);
 		stripe_count = v1->lmm_stripe_count;
diff --git a/fs/lustre/ptlrpc/wiretest.c b/fs/lustre/ptlrpc/wiretest.c
index e336410a6ed1..45adb33a9c56 100644
--- a/fs/lustre/ptlrpc/wiretest.c
+++ b/fs/lustre/ptlrpc/wiretest.c
@@ -1676,10 +1676,10 @@ void lustre_assert_wire_constants(void)
 		 (long long)(int)offsetof(struct lov_comp_md_entry_v1, lcme_cstripe_count));
 	LASSERTF((int)sizeof(((struct lov_comp_md_entry_v1 *)0)->lcme_cstripe_count) == 1, "found %lld\n",
 		 (long long)(int)sizeof(((struct lov_comp_md_entry_v1 *)0)->lcme_cstripe_count));
-	LASSERTF((int)offsetof(struct lov_comp_md_entry_v1, lcme_padding_1) == 46, "found %lld\n",
-		 (long long)(int)offsetof(struct lov_comp_md_entry_v1, lcme_padding_1));
-	LASSERTF((int)sizeof(((struct lov_comp_md_entry_v1 *)0)->lcme_padding_1) == 2, "found %lld\n",
-		 (long long)(int)sizeof(((struct lov_comp_md_entry_v1 *)0)->lcme_padding_1));
+	LASSERTF((int)offsetof(struct lov_comp_md_entry_v1, lcme_compr_type) == 46, "found %lld\n",
+		 (long long)(int)offsetof(struct lov_comp_md_entry_v1, lcme_compr_type));
+	LASSERTF((int)sizeof(((struct lov_comp_md_entry_v1 *)0)->lcme_compr_type) == 1, "found %lld\n",
+		 (long long)(int)sizeof(((struct lov_comp_md_entry_v1 *)0)->lcme_compr_type));
 	BUILD_BUG_ON(LCME_FL_STALE != 0x00000001);
 	BUILD_BUG_ON(LCME_FL_PREF_RD != 0x00000002);
 	BUILD_BUG_ON(LCME_FL_PREF_WR != 0x00000004);
@@ -1689,6 +1689,9 @@ void lustre_assert_wire_constants(void)
 	BUILD_BUG_ON(LCME_FL_NOSYNC != 0x00000020);
 	BUILD_BUG_ON(LCME_FL_EXTENSION != 0x00000040);
 	BUILD_BUG_ON(LCME_FL_PARITY != 0x00000080);
+	BUILD_BUG_ON(LCME_FL_COMPRESS != 0x00000100);
+	BUILD_BUG_ON(LCME_FL_PARTIAL != 0x00000200);
+	BUILD_BUG_ON(LCME_FL_NOCOMPR != 0x00000400);
 	BUILD_BUG_ON(LCME_FL_NEG != 0x80000000);
 
 	/* Checks for struct lov_comp_md_v1 */
@@ -1749,6 +1752,8 @@ void lustre_assert_wire_constants(void)
 		 (long long)LCM_FL_SYNC_PENDING);
 	LASSERTF(LCM_FL_PCC_RDONLY == 8, "found %lld\n",
 		 (long long)LCM_FL_PCC_RDONLY);
+	LASSERTF(LCM_FL_FLR_MASK == 11, "found %lld\n",
+		 (long long)LCM_FL_FLR_MASK);
 
 	/* Checks for struct lmv_mds_md_v1 */
 	LASSERTF((int)sizeof(struct lmv_mds_md_v1) == 56, "found %lld\n",
diff --git a/include/uapi/linux/lustre/lustre_user.h b/include/uapi/linux/lustre/lustre_user.h
index 7ee79e21e8ef..8f648ecd91fa 100644
--- a/include/uapi/linux/lustre/lustre_user.h
+++ b/include/uapi/linux/lustre/lustre_user.h
@@ -425,6 +425,7 @@ struct ll_ioc_lease_id {
 #define LOV_PATTERN_MDT			0x100
 #define LOV_PATTERN_OVERSTRIPING	0x200
 #define LOV_PATTERN_FOREIGN		0x400
+#define LOV_PATTERN_COMPRESS		0x800
 
 #define LOV_PATTERN_F_MASK	0xffff0000
 #define LOV_PATTERN_F_HOLE	0x40000000 /* there is hole in LOV EA */
@@ -586,6 +587,15 @@ enum lov_comp_md_entry_flags {
 	LCME_FL_NOSYNC		= 0x00000020,	/* FLR: no sync for the mirror */
 	LCME_FL_EXTENSION	= 0x00000040,	/* extension comp, never init */
 	LCME_FL_PARITY		= 0x00000080,	/* EC: a parity code component */
+	LCME_FL_COMPRESS	= 0x00000100,	/* the component should be
+						 * compressed
+						 */
+	LCME_FL_PARTIAL		= 0x00000200,	/* some chunks in the component
+						 * are uncompressed
+						 */
+	LCME_FL_NOCOMPR		= 0x00000400,	/* the component should not be
+						 * compressed
+						 */
 	LCME_FL_NEG		= 0x80000000,	/* used to indicate a negative
 						 * flag, won't be stored on disk
 						 */
@@ -640,7 +650,12 @@ struct lov_comp_md_entry_v1 {
 	__u8			lcme_cstripe_count;	/* code stripe count,
 							 * p value in EC
 							 */
-	__u16			lcme_padding_1;
+	__u8			lcme_compr_type;	/* compress type */
+	__u8			lcme_compr_lvl:4;	/* compress level */
+	__u8			lcme_compr_chunk_log_bits:4;
+				     /* chunk_size = 2^(16+chunk_log_bits)
+				      * i.e. power-of-two multiple of 64KiB
+				      */
 } __attribute__((packed));
 
 #define SEQ_ID_MAX		0x0000FFFF